#define MODULE
#include <linux/module.h>
#include <linux/rt_sched.h>
#include <linux/rtf.h>

RT_TASK tarea;

void funcion(int nada) {
	char dato;

	while(1) {
		if (rtf_get(0, &dato, 1) > 0) {
		  rtf_put(1,&dato,1);
		}
		rt_task_wait();
	}
}

int init_module(void) {
	/* Creamos los RTFIFOS */
	rtf_create(0,100);
	rtf_create(1,100);
	rt_task_init(&tarea, funcion, 0, 3000, 1);
	/* Planificar la tarea: ejecutar 100 veces por segundo (100 Hz) */
	rt_task_make_periodic(&tarea,(RTIME)rt_get_time()+
		(RTIME)1000LL,(RTIME) (RT_TICKS_PER_SEC / 100LL));
	printk("TR iniciado...\n");
	return(0);
}

int cleanup_module(void) {
	rt_task_delete(&tarea);
	rtf_destroy(0);
	rtf_destroy(1);
	printk("TR finalizado...\n");
	return(0);
}

